Summary: Software satfinder
Name: gsatfinder
Version: 0.2.3
Release: 1%{dist}
License: GPLv3
Group: Applications/Communications
URL: http://linuxonly.ru
Source:	%{name}-%{version}.tar.bz2
Vendor:	Alex <alex@linuxonly.ru>
BuildArch: x86_64

BuildRequires: pkgconfig
%define gtk3 %(pkg-config --exists 'gtk+-3.0 >= 3.0.0' && echo 1 || echo 0)

%if %gtk3
Requires: gtk3 >= 3.0.0, glib2 >= 2.28.5
BuildRequires: gtk3-devel >= 3.0.0, glib2-devel >= 2.28.5
%else
Requires: gtk2 >= 2.14.0, glib2 >= 2.18.0
BuildRequires: gtk2-devel >= 2.14.0, glib2-devel >= 2.18.0
%endif

%if 0%{?fedora} >= 14
Requires: libcap
%endif

Requires: alsa-lib, pulseaudio-libs, gdbm, zlib
BuildRequires: alsa-lib-devel, pulseaudio-libs-devel, gdbm-devel, zlib-devel, desktop-file-utils, gettext

%description
Simple program for manual satellite antenna installation

%prep
%setup -q

%build
%if %gtk3
%configure --toolkit=gtk3
%else
%configure
%endif
make %{?_smp_mflags}

%install
rm -rf %{buildroot}
make install INSTALLPREFIX=%{buildroot}
desktop-file-install --vendor fedora --dir %{buildroot}%{_datadir}/applications --add-category X-Fedora --delete-original %{buildroot}%{_datadir}/applications/%{name}.desktop
%find_lang gsf

%clean
rm -rf %{buildroot}

%post
%if 0%{?fedora} >= 14
setcap cap_sys_admin,cap_net_admin=pe %{_bindir}/gsfprivileged
%else
chmod +s %{_bindir}/gsfprivileged
%endif

%files -f gsf.lang
%defattr(-,root,root,-)
%doc LICENSE
%doc AUTHORS
%doc Changelog
%{_bindir}/gsfgui
%{_bindir}/gsfstrsvr
%{_bindir}/gsfprivileged
%{_libdir}/gsf/soundmodules/alsasound.so
%{_libdir}/gsf/soundmodules/pulsesound.so
%{_libdir}/gsf/soundmodules/osssound.so
%{_datadir}/pixmaps/gsf.png
%{_datadir}/applications/fedora-%{name}.desktop
%{_datadir}/gsf/gsf.png
%{_datadir}/gsf/calcwindow_header.png
%{_datadir}/gsf/scanwindow_tv.png
%{_datadir}/gsf/svclist_tvradio.png
%{_datadir}/gsf/scanwindow_data.png
%{_datadir}/gsf/svclist_netshare.png
%{_datadir}/gsf/svcparams_wizard.png
%{_datadir}/gsf/satscan_wizard.png
%{_datadir}/gsf/scanwindow_other.png
%{_datadir}/gsf/svclist_internet.png
%{_datadir}/gsf/scanwindow_radio.png
%{_datadir}/gsf/svclist_radio.png
%{_datadir}/gsf/svclist_transponder.png
%{_datadir}/gsf/sound_flag_unknown.png
%{_datadir}/gsf/templates/index.tpl
%{_datadir}/gsf/templates/msg401.tpl
%{_datadir}/gsf/templates/msg403.tpl
%{_datadir}/gsf/templates/msg404.tpl
%{_mandir}/man1/gsfgui.1.gz
%{_mandir}/man1/gsfprivileged.1.gz
%{_mandir}/man1/gsfstrsvr.1.gz

%changelog
* Wed May 25 2011 Alex <alex@linuxonly.ru>
- GTK 3 port
- Changed binary name for comatiblity with libgsf

* Thu Apr 28 2011 Alex <alex@linuxonly.ru>
- Streaming server build fix
- LNB type parameters
- Interferention timezone handling
- Web interface
- And a lot of fixes in release 0.2.1

* Mon Dec 20 2010 Alex <alex@linuxonly.ru>
- Various improvements in streaming server
- Serialization
- Country codes handling while scanning services
- Streaming server clients control
- And a lot of changes in release 0.2.0

* Sun Nov 7 2010 Alex <alex@linuxonly.ru>
- brand new version

* Thu Oct 7 2009 Alex <alex@linuxonly.ru>
- added support for spawning user defined process
- transponder name support
- program can start minimized to tray
- program can minimize instead of exit while closing main window

* Fri Sep 18 2009 Alex <alex@linuxonly.ru>
- added russian locale
- gsfclient rp_filter fix
- device properties dialog fix

* Fri Aug 28 2009 Alex <alex@linuxonly.ru>
- added logo file to package
- gsfclient application with suid bit

* Sun Aug 16 2009 Alex <alex@linuxonly.ru>
- released spec

