<html>
	<head>
		<title>GSF signal status</title>
		<style type="text/css">
			body {
 				font-family: "Liberation Serif", "Liberation Sans", Tahoma, sans-serif;
				font-size: 16px;
			}
			
			#snr, #agc, #ber {
				width: 0px;
				height: 100%;
				background-color: white;
			}
			
			#snrval, #agcval, #berval {
				position: absolute;
				color: black;
				width: 100%;
				text-align: center;
				font-size: 2em;
				font-weight: bold;
			}
			
			#controls {
				position: relative;
				width: 90%;
				height: 10%;
			}
			
			#scales, #services {
				height: 60%;
			}
			
			#workspace {
				background-color:#111;
				opacity: 0.65;
				position:absolute;
				z-index: 1;
				top: 0px;
				left: 0px;
				width: 100%;
			}
			
			#scaledialog {
				position: absolute;
				background-color: #eeeeee;
				width: 400px;
				height: 150px;
				z-index: 2;
			}
			
			#svcdialog {
				position: absolute;
				background-color: #eeeeee;
				width: 400px;
				height: 150px;
				z-index: 2;
			}
						
			a {
				color: #000000;
				text-decoration: none;
				text-align: center;
				font-size: 1.5em;
			}
			
			a:active {
				outline: none;
			}
			
			a:hover {
				text-decoration: none;
				background-color: red;
				color: white;
			}
			
			#header {
				color: black;
				text-align: center;
				width: 100%;
				font-size: 2.0em;
				font-weight: bold;
			}
			
			#container {
				position: relative;
				border-width: 1px;
				border-style: solid;
				border-color: black;
				width: 90%;
				height: 15%;
			}
			
			#servicename {
				font-size: 1.5em;
				font-weight: bold;
			}
			
			#ablock {
				width: 30%;
				height: 100%;
				float: left;
				background-position: top left;
				text-align: center;
			}
			
			#bblock {
				width: 40%;
				height: 100%;
				background-position: top left;
				float: left;
				text-align: center;
			}
			
			#cblock {
				width: 30%;
				height: 100%;
				background-position: top;
				float: right;
				overflow: hidden; 
				text-align: center;
			}
			
			#dialoghdr {
				width: 100%;
				height: 15%;
				font-size: 1.0em;
				font-weight: bold;
				text-align: center;
				background-color: #9DBBE1;
				overflow: hidden;
				top: 0;
				padding: 2px 0px 2px 0px;
			}
			
			#dialogftr {
				width: 100%;
				height: 15%;
				font-size: 1.0em;
				text-align: center;
				overflow: hidden;
				bottom: 0;
				padding: 3px 0px 3px 0px;
			}
		</style>
		
		<script type="text/javascript">
			var httprequest = null;
			var svcrequest = null;
			var readsvclist = false;
		
			function gsf_scale()
			{
				var groundheight = window.innerHeight;
				document.getElementById("container").style.height = groundheight*0.15 + "px";
				document.getElementById("snrval").style.lineHeight = groundheight*0.15 + "px";
				document.getElementById("agcval").style.lineHeight = groundheight*0.15 + "px";
				document.getElementById("berval").style.lineHeight = groundheight*0.15 + "px";
			}
			
			function gsf_get_window_client_height()
			{
				if (typeof window.innerWidth != "undefined") {
					viewportheight = window.innerHeight;
				} else {
					viewportheight = document.documentElement.clientHeight;
				}
				if ((viewportheight > document.body.parentNode.scrollHeight) && (viewportheight > document.body.parentNode.clientHeight)) {
					cliheight = viewportheight;
				} else {
					if (document.body.parentNode.clientHeight > document.body.parentNode.scrollHeight) {
						cliheight = document.body.parentNode.clientHeight;
					} else {
						cliheight = document.body.parentNode.scrollHeight;
					}
				}
				
				return cliheight;
			}
			
			function gsf_get_window_client_width()
			{
				if (typeof window.innerWidth != "undefined") {
					viewportwidth = window.innerWidth;
				} else {
					viewportwidth = document.documentElement.clientWidth;
				}
				if ((viewportwidth > document.body.parentNode.scrollWidth) && (viewportwidth > document.body.parentNode.clientWidth)) {
					cliwidth = viewportwidth;
				} else {
					if (document.body.parentNode.clientWidth > document.body.parentNode.scrollWidth) {
						cliwidth = document.body.parentNode.clientWidth;
					} else {
						cliwidth = document.body.parentNode.scrollWidth;
					}
				}
				
				return cliwidth;
			}
						
			function gsf_show_dialog(name) {
				if ((name == "svcdialog") && (!readsvclist)) {
					var message;
					message  = "Unable to change service because of GSF settings";
					message += "\nPlease turn on \"Export services list\" option";
					message += "\nin preferences menu and reload page in browser";
					alert(message);
					return;
				}
			
				var workspace = document.getElementById("workspace");
				var dialog = document.getElementById(name);
				
				var cliheight = gsf_get_window_client_height();
				var cliwidth = gsf_get_window_client_width();
				var dialogheight = cliheight / 2 - 75;
				var dialogwidth = cliwidth / 2 - 200;
				
				workspace.style.height = cliheight + "px";
				dialog.style.top = dialogheight + "px";
				dialog.style.left = dialogwidth + "px";
				
				workspace.style.display = "block";
				dialog.style.display = "block";
			}
			
			function gsf_hide_dialog(name) {
				var workspace = document.getElementById("workspace");
				var dialog = document.getElementById(name);
				
				workspace.style.display = "none";
				dialog.style.display = "none";
			}
			
			function gsf_test_integer(value) {
				var result = false;
				
				value = parseInt(value);
				
				if ((typeof value === "number") && (isFinite(value)) && (Math.ceil(value) == Math.floor(value))) {
					result = true;
				}
				
				return result;
			}
			
			function gsf_parse_integer(strval, maxval, defval)
			{
				var tmpscint;
				
				if (gsf_test_integer(strval)) {
					tmpscint = parseInt(strval);
					if ((tmpscint <= maxval) && (tmpscint > 0)) {
						return tmpscint;
					}
				}
				return defval;
			}
			
			function gsf_random_integer(lowbound, highbound)
			{
				var value = 0;
				
				do {
					value = Math.floor(Math.random() * (highbound - lowbound + 1) + lowbound);
				} while(value == 0);
				
				return value;
			}
			
			function gsf_write_scales()
			{
				var snrscval = document.getElementById("snrscale").value;
				var agcscval = document.getElementById("agcscale").value;
				var berscval = document.getElementById("berscale").value;
				
				var snrscint = gsf_parse_integer(snrscval, 65535, 100);
				var agcscint = gsf_parse_integer(agcscval, 65535, 1000);
				var berscint = gsf_parse_integer(berscval, 4294967296, 1000);
				
				var cookieval = snrscint + '/' + agcscint + '/' + berscint;
				
				var expdate = new Date ();
				
				expdate.setTime(expdate.getTime() + 1000 * 60 * 60 * 24 * 365);
				
				document.cookie = "scales=" + escape(cookieval) + "; expires=" + expdate.toGMTString() + "; path=/";
			}
			
			function gsf_read_scales()
			{
				var cname = "scales";
				var cookies = document.cookie;
				
				var scales = new Array();
				
				scales["snr"] = 100;
				scales["agc"] = 1000;
				scales["ber"] = 1000;
				
				if (cookies.indexOf(cname) != -1) {
					var startpos = cookies.indexOf(cname) + cname.length + 1;
					var endpos = cookies.indexOf(";", startpos) - 1;
					if (endpos == -2) endpos = cookies.length;
					
					var cookieval = unescape(cookies.substring(startpos, endpos));
					
					strvalues = cookieval.split("/", 3);
					
					if (strvalues.length == 3) {
						scales["snr"] = gsf_parse_integer(strvalues[0], 65535, 100);
						scales["agc"] = gsf_parse_integer(strvalues[1], 65535, 1000);
						scales["ber"] = gsf_parse_integer(strvalues[2], 4294967296, 1000);
					}
				}
				
				return scales;
			}
			
			function gsf_create_http_request_object() {
				var reqobject;
				var browser = navigator.appName;
				if (browser == "Microsoft Internet Explorer") {
					reqobject = new ActiveXObject("Microsoft.XMLHTTP");
				} else {
					reqobject = new XMLHttpRequest();
				}
				return reqobject;
			}
			
			function gsf_receive_signal_status_cb()
			{
				var signal = new Array();
				
				//document.getElementById('dbgcon').value="Wait server...";
				
				if (httprequest.readyState == 4) {
					setTimeout("gsf_receive_signal_status(httprequest)", 1000);
					if (httprequest.status == 200) {
						var xml = httprequest.responseXML;
						var root = xml.getElementsByTagName("netanswer").item(0);
						
						signal["ip"] = "127.0.0.1";
						signal["nodename"] = "Localhost";
						signal["svcname"] = "Unknown";
						signal["snr"] = "0";
						signal["agc"] = "0";
						signal["ber"] = "0";
						signal["lock"] = "0";
						signal["carrier"] = "0";
						
						if (root.attributes) {
							signal["ip"] = root.getAttribute("ip");
							signal["nodename"] = root.getAttribute("nodename");
						}
						
						signal["svcname"] = root.getElementsByTagName("name")[0].childNodes[0].nodeValue;
						signal["snr"] = root.getElementsByTagName("snr")[0].childNodes[0].nodeValue;
						signal["agc"] = root.getElementsByTagName("agc")[0].childNodes[0].nodeValue;
						signal["ber"] = root.getElementsByTagName("ber")[0].childNodes[0].nodeValue;
						signal["lock"] = root.getElementsByTagName("lock")[0].childNodes[0].nodeValue;
						signal["carrier"] = root.getElementsByTagName("carrier")[0].childNodes[0].nodeValue;
						
						gsf_read_signal(signal);
						//document.getElementById('dbgcon').value = signal["nodename"] + " " + signal["snr"];
					}// else {
					//	document.getElementById('dbgcon').value="Error: returned status code " + request.status + " " + request.statusText;
					//}	
				}
			}
			
			function gsf_receive_signal_status(httprequest)
			{
				httprequest.onreadystatechange = gsf_receive_signal_status_cb;
				httprequest.open("GET", "status.xml", true);
				httprequest.send(null);
				
			}
			
			function gsf_read_signal(signal)
			{	
				var indicators = new Array("snr", "agc", "ber");
				var color = "red";
				var maxval = 65535;
				var level = 0;
				var text = "";
				
				var scales = gsf_read_scales();
				
				var node = document.getElementById("servicename");
				if (node.innerHTML != signal["svcname"]) node.innerHTML = signal["svcname"];
				
				
				for(var i = 0; i < indicators.length; i++) {
					if (indicators[i] == "ber") maxval = 4294967296; else maxval = 65535;
					level = (gsf_parse_integer(signal[indicators[i]], maxval, 0)/scales[indicators[i]])*100;
					if (level > 100) level = 100;
					if (level <= 40) {
						color = "red";
					} else if (level <= 60) {
						color = "yellow";
					} else {
						color = "green";
					}
					
					node = document.getElementById(indicators[i]);
					node.style.width = level + '%';
					node.style.backgroundColor = color;
					
					node = document.getElementById(indicators[i]+"val");
					if (indicators[i] == "snr") {
						if (signal["lock"] == "1") text = signal["snr"] + " LOCK"; else text = signal["snr"];
					} else if (indicators[i] == "agc") {
						if (signal["carrier"] == "1") text = signal["agc"] + " CARRIER"; else text = signal["agc"];
					} else if (indicators[i] == "ber") {
						text = signal["ber"];
					}
					if (node.innerHTML != text) node.innerHTML = text;
				}
			}
			
			function gsf_receive_service_list_cb()
			{
				var services = new Array();
				
				//document.getElementById('dbgcon').value="Requesting service list...";
				
				if (svcrequest.readyState == 4) {
					if (svcrequest.status == 200) {
						var xml = svcrequest.responseXML;
						var root = xml.getElementsByTagName("servicelist").item(0);
						var svcs = root.getElementsByTagName("service");
						
						for (var i=0; i<svcs.length; i++) {
							var svcstruct = new Array(2);
							svcstruct[0] = svcs[i].childNodes[0].nodeValue;
							svcstruct[1] = svcs[i].getAttribute("id");
							services[i] = svcstruct;
						}
						
						if (svcs.length > 0) {
							gsf_read_service_list(services);
							readsvclist = true;
						}
						//document.getElementById('dbgcon').value = xml;
					}
				}
			}
			
			function gsf_receive_service_list(request)
			{
				request.onreadystatechange = gsf_receive_service_list_cb;
				request.open("GET", "services.xml", true);
				request.send(null);
			}
			
			function gsf_read_service_list(services)
			{
				if (services) {
					var combobox = document.getElementById("svcselect");
					for(var i = 0; i < services.length; i++) {
						var service = new Option;
						svcstruct = services[i];
						service.text = svcstruct[0];
						service.value = svcstruct[1];
						combobox.options[i] = service;
					}
				}
			}
			
			function gsf_select_service_cb()
			{
				var control = new Array(2);
				//var result = false;
				
				control[0] = "Unknown error"
				control[1] = "0"
							
				if (svcrequest.readyState == 4) {
					if (svcrequest.status == 200) {
						var xml = svcrequest.responseXML;
						var root = xml.getElementsByTagName("control").item(0);
						var cmd = root.getElementsByTagName("command");
						
						if (cmd.length > 0) {
							control[0] = cmd[0].childNodes[0].nodeValue;
							control[1] = cmd[0].getAttribute("result");
						}
					}
					
					if (control[1] != "1") {
						var message;
						message  = "Unable to tune selected service";
						message += "\nReason: " + control[0];
						alert(message);
					}
					
				}
			}
			
			function gsf_select_service()
			{
				var combobox = document.getElementById("svcselect");
				var id = combobox.options[combobox.selectedIndex].value;
				var seq = gsf_random_integer(1, 4294967296);
				var request = "control.xml?cmd=1&id="+id+"&seq="+seq;
				
				svcrequest.onreadystatechange = gsf_select_service_cb;
				svcrequest.open("GET", request, true);
				svcrequest.send(null);
			}
			
			function gsf_initialize()
			{
				var obj = document.getElementById("noscript");
				obj.style.display = "none";
				
				var array = new Array();
				array = document.getElementsByName("jsonly");
				
				for(var i = 0; i < array.length; i++) {
					obj = array[i];
					obj.style.display = "";
				}
				
				gsf_scale();
				window.onresize = gsf_scale;
				
				scales = gsf_read_scales();
				document.getElementById("snrscale").value = scales["snr"];
				document.getElementById("agcscale").value = scales["agc"];
				document.getElementById("berscale").value = scales["ber"];
				
				httprequest = gsf_create_http_request_object();
				gsf_receive_signal_status(httprequest);
				
				svcrequest = gsf_create_http_request_object();
				gsf_receive_service_list(svcrequest);
				
				//var progress_run_id = setInterval(gsf_receive_signal_status, 1000);
			}
			
		</script>
				
	</head>
	
	<body onload="gsf_initialize();">
	
	<div id="noscript">Your browser does not support JavaScript!</div>
	
	 
	<div id="workspace" style="display:none;"></div>
		
	<div id="scaledialog" style="display:none;">
		<div id="dialoghdr">Scales</div> 
		
		<table id="scales" align="center">
			<tr>
				<td>SNR value scale:</td>
				<td><input type="text" name="snrscale" id="snrscale" value="100" size="10" maxlength="5" /></td>
			</tr>

			<tr>
				<td>AGC value scale:</td>
				<td><input type="text" name="agcscale" id="agcscale" value="1000" size="10" maxlength="5" /></td>
			</tr>
			
			<tr>
				<td>BER value scale:</td>
				<td><input type="text" name="berscale" id="berscale" value="1000" size="10" maxlength="10" /></td>
			</tr>
		</table>
		
		<div id="dialogftr">
			<input type="button" name="setscale" value="Apply" size="5" onclick="gsf_write_scales(); gsf_hide_dialog('scaledialog');" /> &nbsp;
			<input type="button" name="closescale" value="Close" size="5" onclick="gsf_hide_dialog('scaledialog');" />
		</div> 
	</div>
	
	<div id="svcdialog" style="display:none;">
		<div id="dialoghdr">Services</div> 
		
		<table id="services" align="center">
			<tr>
				<td>Service:</td>
				<td><select id="svcselect" name="svcselect"></select></td>
			</tr>
		</table>
		
		<div id="dialogftr">
			<input type="button" name="svcset" value="Select" size="5" onclick="gsf_select_service(); gsf_hide_dialog('svcdialog');" /> &nbsp;
			<input type="button" name="svcclose" value="Close" size="5" onclick="gsf_hide_dialog('svcdialog');" />
		</div>
	</div>
	
	<span name="jsonly" style="display: none;" >
		<br> <div align="center">
			<div id="header">GSF signal status</div>
		</div>
		
		<br> <div align="center">
			<div id="container" align="left">
				<div id="snr">
					<div id="snrval" >0</div>
				</div> 
			</div>
		</div>
		
		<br> <div align="center">
			<div id="container" align="left">
				<div id="agc">
					<div id="agcval">0</div>
				</div> 
			</div>
		</div>
		
		<br> <div align="center">
			<div id="container" align="left">
				<div id="ber">
					<div id="berval">0</div>
				</div> 
			</div>
		</div>
		
		<br> <div align="center"> 
			<div align="left" id="controls">
				<div id="ablock">
					<a href="#" onclick="gsf_show_dialog('svcdialog')">Change service</a>
				</div>
				
				<div id="bblock">
					<div id="servicename">Service name</div>
				</div>
				
				<div id="cblock">
					<a href="#" onclick="gsf_show_dialog('scaledialog')">Set scales</a>
				</div>
			</div>
		</div>
		
		<!-- <br> <div id="dbg" align="left">
			<input id="dbgcon" name="console" size="32" type="text">
		</div>  -->
				
	</span>
	
	</body>
</html>
