/*
 *      calculations.h
 *      
 *      Copyright 2009 - 2011 Alex <alex@linuxonly.ru>
 *      
 *      This program is free software: you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 3 of the License, or
 *      (at your option) any later version.
 *      
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *      
 *      You should have received a copy of the GNU General Public License
 *      along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __CALCULATIONS_H__
#define __CALCULATIONS_H__

#include <gtk/gtk.h>

typedef struct _intperiod intperiod;
typedef struct _sunmoonpos sunmoonpos_t;

struct _intperiod {
	time_t start;
	time_t end;
};

struct _sunmoonpos {
	gdouble sunazimuth;
	gdouble sunaltitude;
	gdouble sunsat;
	gdouble moonazimuth;
	gdouble moonaltitude;
	gdouble moonsat;
};

void calculations_multifeed(gfloat longitude, gfloat latitude, gfloat sat1longitude, gfloat sat2longitude, gfloat altitude, gfloat focuslen, gfloat *xoffset, gfloat *yoffset);
gfloat calculations_azimuth(gfloat longitude, gfloat latitude, gfloat satlongitude, gfloat altitude);
gfloat calculations_elevation(gfloat longitude, gfloat latitude, gfloat satlongitude, gfloat altitude);
gfloat calculations_declination(gfloat latitude, gfloat azimuth, gfloat elevation);
gfloat calculations_hourangle(gfloat latitude, gfloat azimuth, gfloat elevation);
gfloat calculations_polangle(gfloat longitude, gfloat latitude, gfloat satlongitude);
gfloat calculations_satheight(gfloat longitude, gfloat latitude, gfloat satlongitude);
sunmoonpos_t *calculations_sunmoon_tracker(gdouble longitude, gdouble latitude, time_t timestamp, sunmoonpos_t *sunmoonpos);
GSList *calculations_interferention_main(gdouble longitude, gdouble latitude, gdouble satlongitude, gshort year, gchar season, gchar band, gdouble dsize);


#endif /* __CALCULATIONS_H__ */
