/*
 *      calcwindow.h
 *      
 *      Copyright 2011 Alex <alex@linuxonly.ru>
 *      
 *      This program is free software: you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 3 of the License, or
 *      (at your option) any later version.
 *      
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *      
 *      You should have received a copy of the GNU General Public License
 *      along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __CALCWINDOW_H__
#define __CALCWINDOW_H__

#include <gtk/gtk.h>

#include "calculations.h"

enum {
	CALC_PREFERENCE_ID_MENU = -1,
	CALC_PREFERENCE_ID_PLACE = 0,
	CALC_PREFERENCE_ID_ANTENNA,
	CALC_PREFERENCE_ID_ALIGNMENTS,
	CALC_PREFERENCE_ID_MULTIFEED,
	CALC_PREFERENCE_ID_TRACE,
	CALC_PREFERENCE_ID_OUTAGE
};

struct _calcdata {
	gdouble satlong;
	gdouble sitelong;
	gdouble sitelat;
	guint season;
	guint year;
	gdouble dishdiameter;
	gdouble dishfocuslen;
	guint dishband;
	gdouble sat2long;
	//calculated
	/*gdouble sunazimuth;
	gdouble sunaltitude;
	gdouble sunsat;
	gdouble moonazimuth;
	gdouble moonaltitude;
	gdouble moonsat;*/
	sunmoonpos_t sunmoonpos;
};

gboolean calcwindow_create(GtkWindow *parentwin);
void calcwindow_set_expired_page(gint preference);
void calcwindow_update_page(gint preference);

#endif /* __CALCWINDOW_H__ */
