/*
 *      iso3166.h
 *      
 *      Copyright 2009 - 2010 Alex <alex@linuxonly.ru>
 *      
 *      This program is free software: you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 3 of the License, or
 *      (at your option) any later version.
 *      
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *      
 *      You should have received a copy of the GNU General Public License
 *      along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __ISO3166_H__
#define __ISO3166_H__

unsigned short iso3166_get_code_from_a3(const char *a3);
char *iso3166_get_a3_from_code(unsigned short code);
char *iso3166_get_a3_from_code_static(unsigned short code, char *buffer);
unsigned short iso3166_get_code_from_a2(const char *a2);
char *iso3166_get_a2_from_code(unsigned short code);
char *iso3166_get_country_from_code(unsigned short code);
char *iso3166_get_country_from_a3(const char *a3);
char *iso3166_get_country_from_a2(const char *a2);
unsigned short iso3166_get_code_from_locale(const char *locale);
unsigned short iso3166_get_code_from_locale_env(void);

#endif /* __ISO3166_H__ */
