/*
 *      odf.h
 *      
 *      Copyright 2012 Alex <alex@linuxonly.ru>
 *      
 *      This program is free software: you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 3 of the License, or
 *      (at your option) any later version.
 *      
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *      
 *      You should have received a copy of the GNU General Public License
 *      along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __ODF_H__
#define __ODF_H__

#include <stdarg.h>

struct _odf {
	char *filename;
	char *application;
	char *content;
	time_t createtime;
	char *table;
	unsigned int tablecols;
};

typedef struct _odf *odf_t;

void odf_add_heading(odf_t instance, int outlinelevel, char *text);
void odf_add_paragraph(odf_t instance, char *text);
void odf_add_link(odf_t instance, char *link, char *text);
void odf_add_list(odf_t instance, char *entry, ...);
void odf_add_table_header(odf_t instance, unsigned int columns, char *header, ...);
void odf_add_table_row(odf_t instance, char *text, ...);
void odf_add_table_footer(odf_t instance);
void odf_add_paragraph_with_caption(odf_t instance, char *prefix, char *caption, char *text);
odf_t odf_init(char *filename, char *application);
void odf_close(odf_t instance);

#endif /* __ODF_H__ */
