/*
 *      serialize.h
 *      
 *      Copyright 2009 - 2010 Alex <alex@linuxonly.ru>
 *      
 *      This program is free software: you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 3 of the License, or
 *      (at your option) any later version.
 *      
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *      
 *      You should have received a copy of the GNU General Public License
 *      along with this program. If not, see <http://www.gnu.org/licenses/>.
 */
 
#ifndef __SERIALIZE_H__
#define __SERIALIZE_H__

#include <stdarg.h>

#define MSGOFFSET(n, s) ( ((n) * (s) + sizeof(unsigned int) + sizeof(char)) )
#define SERIALIZE_REQUEST(b) ( ((unsigned char)((b)[0])) )
#define SERIALIZE_FORM_REQSTR(b, r, s) (strncpy( (b), (r), (s) ))

unsigned int serialize_get_size(char *format);
char *serialize_form_message(char *format, int endianess, size_t *size, ...);
int serialize_parse_message(char *format, char *message, int endianess, ...);
int serialize_parse_message_static(char *format, char *message, int endianess, ...);

char *serialize_form_array_message(char *format, char cmd, unsigned int rows, size_t *size, void (callback)(unsigned int *params, unsigned int count, int seq, int size, char **buffer, void *data), void *data);
void serialize_form_message_buffer(unsigned int *params, unsigned int count, char **buf, unsigned int offset, ...);
int serialize_parse_array_message(char *format, unsigned int *arows, char *message, char *acmd, void (callback)(unsigned int *params, unsigned int count, int seq, int size, char **message, void *data), void *data);
void serialize_parse_message_buffer(unsigned int *params, unsigned int count, char **msg, unsigned int offset, ...);

void serialize_fill_static_string(char *svalue, char *value, size_t length);

#endif /* __SERIALIZE_H__ */
