/*
 *      zip.h
 *      
 *      Copyright 2012 Alex <alex@linuxonly.ru>
 *      
 *      This program is free software: you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 3 of the License, or
 *      (at your option) any later version.
 *      
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *      
 *      You should have received a copy of the GNU General Public License
 *      along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __ZIP_H__
#define __ZIP_H__

enum _zipwriter_method {
	ZIPWRITER_METHOD_STORE = 0,
	ZIPWRITER_METHOD_DEFLATE
};

struct _zipwriter {
	int fd;
	enum _zipwriter_method method;
	size_t localheaderoffset;
	unsigned int centraldirnumber;
	size_t centraldirsize;
	unsigned char *centraldir;
};

typedef struct _zipwriter *zipwriter_t;

unsigned int zipwriter_add_data_file(zipwriter_t instance, char *filename, char *data, size_t size);
unsigned int zipwriter_add_directory(zipwriter_t instance, char *dirname);
void zipwriter_set_method(zipwriter_t instance, enum _zipwriter_method method);
zipwriter_t zipwriter_init(char *filename);
void zipwriter_close(zipwriter_t instance);

#endif /* __ZIP_H__ */
