/*
 *      dvbname.h
 *      
 *      Copyright 2009 - 2010 Alex <alex@linuxonly.ru>
 *      
 *      This program is free software: you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 3 of the License, or
 *      (at your option) any later version.
 *      
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *      
 *      You should have received a copy of the GNU General Public License
 *      along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __DVBNAME_H__
#define __DVBNAME_H__

#include <gtk/gtk.h>

#define SYSFS_SMALL_BUFFER   16
#define SYSFS_BIG_BUFFER     256
#define SYSFS_GET_BUFSIZE(x) ( ((x) <= 3) ? SYSFS_SMALL_BUFFER : SYSFS_BIG_BUFFER )

#define SYSFS_DB_LEVEL1_OFFSET  6
#define SYSFS_DB_LEVEL2_OFFSET  7

#define FRONTEND_TEMPLATE "/dev/dvb/adapter%i/frontend%i"

enum {
	DVBNAME_DEVICE_BUS_PCI = 0,
	DVBNAME_DEVICE_BUS_USB
};

//gint dvbname_enum_adapters(gint (*add_frontend_cb)(gchar *name, gchar *vendor, gint subdevice, gint subvendor, gint adapter, gint frontend));
GSList *dvbname_scan_devices(void);
void dvbname_free_devices(GSList **devices);
gchar *dvbname_get_frontend_filename(gint adapter, gint frontend);

#endif /* __DVBNAME_H__ */
