/*
 *      gsfshm.h
 *      
 *      Copyright 2009 - 2010 Alex <alex@linuxonly.ru>
 *      
 *      This program is free software: you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 3 of the License, or
 *      (at your option) any later version.
 *      
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *      
 *      You should have received a copy of the GNU General Public License
 *      along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __GSFSHM_H__
#define __GSFSHM_H__

#include <net/if.h>
#include "../resources.h"
 
#define PRIVILEGED_TOKEN_FILE    RESOURCE_BINARY_PRIVILEGED
#define PRIVILEGED_PROJID        0x0001

#define PRIVILEGED_STATUS_OK              0
#define PRIVILEGED_STATUS_NETIF_ERROR     1
#define PRIVILEGED_STATUS_ROUTE_ERROR     2
#define PRIVILEGED_STATUS_SHM_ERROR       3
 
enum {
	PRIVILEGED_ACTION_START_NET = 0,
	PRIVILEGED_ACTION_STOP_NET,
	PRIVILEGED_ACTION_ADD_MULTICAST_ROUTE,
	PRIVILEGED_ACTION_REMOVE_MULTICAST_ROUTE
};
 
struct srequest {
	int action;
	int adapter;
	int frontend;
	int netpid;
	char ipaddress[16];
	char netmask[16];
	char macaddress[18];
	int interface;
	char intname[IFNAMSIZ];
	char remintname[IFNAMSIZ];
};

#endif /* __GSFSHM_H__ */
