/*
 *      saferwlocks.h
 *      
 *      Copyright 2010 Alex <alex@linuxonly.ru>
 *      
 *      This program is free software: you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 3 of the License, or
 *      (at your option) any later version.
 *      
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *      
 *      You should have received a copy of the GNU General Public License
 *      along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

#include <sys/types.h>
#include <sys/ipc.h>

#ifndef __SAFERWLOCKS_H__
#define __SAFERWLOCKS_H__

typedef char * rwlockshed_t;

void rwlockshed_init(rwlockshed_t *rwlockshed, key_t svkey, int maxprocesses, int latency);
void rwlockshed_destroy(rwlockshed_t rwlockshed);
void rwlockshed_readlock(rwlockshed_t rwlockshed);
void rwlockshed_readunlock(rwlockshed_t rwlockshed);
void rwlockshed_writelock(rwlockshed_t rwlockshed);
void rwlockshed_writeunlock(rwlockshed_t rwlockshed);

#endif /* __SAFERWLOCKS_H__ */
