/*
 *      signalshed.h
 *      
 *      Copyright 2010 Alex <alex@linuxonly.ru>
 *      
 *      This program is free software: you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 3 of the License, or
 *      (at your option) any later version.
 *      
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *      
 *      You should have received a copy of the GNU General Public License
 *      along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

#include <sys/types.h>

#ifndef __SIGNALSHED_H__
#define __SIGNALSHED_H__

typedef struct _signalshed * signalshed_t;

struct _signalshed {
	int semid;
	int maxclients;
	pid_t *clients;
};

void signalshed_init(signalshed_t *signalshed, key_t svkey, int maxprocesses);
void signalshed_destroy(signalshed_t signalshed);
void signalshed_add_client(signalshed_t signalshed, pid_t pid, int seq);
void signalshed_remove_client(signalshed_t signalshed, pid_t pid, int seq);
void signalshed_wait_value(signalshed_t signalshed, int val);
void signalshed_wait(signalshed_t signalshed);
void signalshed_post(signalshed_t signalshed);
void signalshed_continue(signalshed_t signalshed);
int signalshed_main(signalshed_t signalshed, int *index, unsigned int *errorcount, unsigned int *idlecount, int (*send_cb)(int *index, unsigned int *errorcount, unsigned int *idlecount));

#endif /* __SIGNALSHED_H__ */
