/*
 *      svrsettings.h
 *      
 *      Copyright 2010 Alex <alex@linuxonly.ru>
 *      
 *      This program is free software: you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 3 of the License, or
 *      (at your option) any later version.
 *      
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *      
 *      You should have received a copy of the GNU General Public License
 *      along with this program. If not, see <http://www.gnu.org/licenses/>.
 */
 
#ifndef __SVRSETTINGS_H__
#define __SVRSETTINGS_H__

#define UDP_BROADCAST_ADDRESS   "127.0.0.255"
#define UDP_BROADCAST_INTERFACE "lo"
#define UDP_BROADCAST_PORT      4000
#define UDP_MULTICAST_INTERFACE "lo"
#define UDP_MULTICAST_GROUP     "225.0.0.0"
#define UDP_MULTICAST_PORT      4000
#define UDP_MULTICAST_LOOPBACK  1
#define UDP_MULTICAST_TTL       1
#define TCP_UNICAST_ADDRESS     "127.0.0.1"
#define TCP_UNICAST_PORT        4000
#define TCP_UNICAST_QUEUE       10
#define TCP_UNICAST_CLIENTS     10

struct _svrsettings {
	char request;
	char result;
	/*UDP BROADCAST*/
	char udpbcint[IFNAMSIZ];
	unsigned short udpbcport;
	/*UDP MULTICAST*/
	char udpmcint[IFNAMSIZ];
	char udpmcgroup[INET_ADDRSTRLEN];
	unsigned short udpmcport;
	char udpmcloop;
	char udpmcttl;
	/*TCP UNICAST*/
	unsigned short tcpucport;
	char tcpucclients;
	char tcpucqueue;
	/*FLAGS*/
	char recordstatus;
	char udpbcstatus;
	char udpmcstatus;
	char tcpucstatus;
	/*SERVICE DESCRIPTION*/
	char servicename[256];
	uint8_t mediatypes[256];
	uint16_t mediastreams[256];
	uint16_t caid;
	char cakey[256];
	/*DEVICE*/
	char adapter;
	char dvr;
	/*STATISTICS*/
	char udpmcclientsnum;
	char udpbcclientsnum;
	unsigned int tcpucclientsnum;
	unsigned int tcpucclientslimit;
	time_t lastsessiontime;
	/*INTERNAL PARAMETERS*/
	int sheduler;
	unsigned int clientid;
};

int svrsettings_init(void);
void svrsettings_config_apply_settings(struct _svrsettings *sp, struct memblock *procmblock);
void svrsettings_read_control_socket(int ctlsockfd, struct memblock *procmblock);
void svrsettings_read_config_file(struct _svrsettings *sp, int firsttime);

#endif /* __SVRSETTINGS_H__ */
