/*
 *      satscanwindow.h
 *      
 *      Copyright 2009 - 2010 Alex <alex@linuxonly.ru>
 *      
 *      This program is free software: you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 3 of the License, or
 *      (at your option) any later version.
 *      
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *      
 *      You should have received a copy of the GNU General Public License
 *      along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __SATSCANWINDOW_H__
#define __SATSCANWINDOW_H__

#include <gtk/gtk.h>
#include "gsfcore.h"

enum {
	SATSCAN_BAND_C = 0,
	SATSCAN_BAND_KU
};

struct _transponder {
	guint   id;
	guint   freq;
	guint   sr;
	guchar  pol;
	guchar  fec;
	guchar  sys;
	guchar  mod;
	guchar  rof;
	guint16 signal;
	gboolean tuned;
	gboolean sticky;
};

typedef struct _transponders *transponders_t;

struct _transponders {
	GSList *list;
	GSList *svclist;
	guint cbandnum;
	guint kubandnum;
	guchar port10;
	guchar port11;
	guchar repeats11;
	guchar band;
};

struct _satscanprogress {
	gfloat full;
	gfloat step;
	gchar tpstring[256];
	guchar band;
	gboolean (*status_callback)(gpointer data);
	struct _frontend *frontend;
};

gboolean satscan_window_create(GtkWindow *rootwindow);

transponders_t satscan_window_get_transponders(void);
gboolean satscan_window_scan_status_fill(gpointer data);
gboolean satscan_window_scan(struct _frontend *frontend);

#endif /* __SATSCANWINDOW_H__ */
