/*
 *      settings.h
 *      
 *      Copyright 2009 - 2010 Alex <alex@linuxonly.ru>
 *      
 *      This program is free software: you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 3 of the License, or
 *      (at your option) any later version.
 *      
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *      
 *      You should have received a copy of the GNU General Public License
 *      along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __SETTINGS_H__
#define __SETTINGS_H__

#include <gtk/gtk.h>

gboolean settings_open(gboolean autoflush);
gboolean settings_close(void);
gboolean settings_flush(void);
gboolean settings_append_string(gchar *name, gchar *value);
gchar *settings_read_string(gchar *name, gchar *def);
gboolean settings_append_int(gchar *name, gint value);
gint settings_read_int(gchar *name, gint def);
gboolean settings_append_float(gchar *name, gdouble value);
gdouble settings_read_float(gchar *name, gdouble def);
gboolean settings_append_boolean(gchar *name, gboolean value);
gboolean settings_read_boolean(gchar *name, gboolean def);

#endif /* __SETTINGS_H__ */
