/*
 *      udpclient.h
 *      
 *      Copyright 2009 - 2012 Alex <alex@linuxonly.ru>
 *      
 *      This program is free software: you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 3 of the License, or
 *      (at your option) any later version.
 *      
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *      
 *      You should have received a copy of the GNU General Public License
 *      along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __UDPCLIENT_H__
#define __UDPCLIENT_H__

#include <glib.h>
#include "gsfcore.h"
#include "dbstorage.h"

typedef enum {
	GSF_UDPCLIENT_ERROR,
} GSFNetError;

enum {
	UDPCLIENT_STATUS_LIST_REFRESH = 0,
};

typedef void (*udpclient_status_callback)(gint event, gpointer data);

gboolean udpclient_init(struct _netgate *netgate);
gboolean udpclient_connect(struct _netgate *netgate);
gboolean udpclient_set_parameters(struct _netgate *netgate, gchar *address, gushort port, gchar *password);
gboolean udpclient_disconnect(struct _netgate *netgate);
gboolean udpclient_get_signal_status(struct _netgate *netgate, struct _service *svc, struct _frontend *frontend);
gboolean udpclient_tune_service(struct _netgate *netgate);
gboolean udpclient_set_status_callback(udpclient_status_callback callback);

#endif /* __UDPCLIENT_H__ */
