/*
 *      udpintctl.h
 *      
 *      Copyright 2009 - 2010 Alex <alex@linuxonly.ru>
 *      
 *      This program is free software: you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 3 of the License, or
 *      (at your option) any later version.
 *      
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *      
 *      You should have received a copy of the GNU General Public License
 *      along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __UDPINTCTL_H__
#define __UDPINTCTL_H__

#include <stdio.h>
#include <stdlib.h>

#define MIN_RETS_TIME    2
#define MAX_RETS_TIME   60
#define MAX_TS_ATTEMPTS  3

#define UDP_HEADER_FORMAT "%b%i%l%i%l"
//%b[flags]%i[seq]%l[timestamp]%i[imito]%l[syncro] + endianess

struct _rtt {
	float last_rtt;     //last masured transmission time
	float smooth_rtt;   //smoothed transmission time
	float variable_rtt; //peak transmission time
	float present_rto;  //retransmission timeout
	int transmissions;  //transmissions number
	time_t unixtime;    //time when transmission started
};

float udpintctl_calc(struct _rtt *rtt);
float udpintctl_round(float rtt);
void udpintctl_new(struct _rtt *rtt);
time_t udpintctl_timestamp(struct _rtt *rtt);
void udpintctl_packet_new(struct _rtt *rtt);
int udpintctl_packet_start(struct _rtt *rtt);
void udpintctl_packet_stop(struct _rtt *rtt, unsigned int ms);
int udpintctl_timeout(struct _rtt *rtt);

#endif /* __UDPINTCTL_H__ */
